﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;



public class GameLogic : MonoBehaviour {

	public static string[] nextscenename = {"1_uno","2_dos","3_tres","4_cuatro","5_cinco","z_final"};
	public static string endnextscene = "0_intro";

	public static GameLogic thegame;
	LevelLogic level;

	public static GameLogic Instance() {
		return thegame;
	}


	void Awake () {
		Debug.Log("awaken");
		GameLogic thisgame = gameObject.GetComponent<GameLogic>();
		if (thegame == null) {
			DontDestroyOnLoad(gameObject);
			thegame=thisgame;
			StartLevel();
		} else {
			if (thegame!=thisgame) {
				thegame.StartLevel();
				Destroy(gameObject);
			} else {
				// se ha llamado awake otra vez
			}
		}
	}
	
	public void StartLevel() {
		level = LevelLogic.Instance();
		Debug.Log("este es el nivel "+level.levelnum);
	}

	public void LoadNextLevel() {
		string nextname;
		int thislevel = level.levelnum;

		if (thislevel<1000) {
			nextname=nextscenename[level.levelnum];
		} else {
			nextname=endnextscene;
		}

		SceneManager.LoadScene(nextname);
	}

}
