﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody2D))]
[RequireComponent(typeof(Animator))]

public class Controller : MonoBehaviour {

	public float maxv = 10;	
	public float jump_vy = 5;	

	public int max_jumps = 1;

	public LayerMask groundlayers;

	public LayerMask killLayers;

	public LayerMask endLayers;


	// public para comunicacion
	public float joy_x = 0;
	public bool start_jump =false;

	Rigidbody2D body;
	GameAudio audio;
	LevelLogic level;

	Animator anim;

	public bool dead;
	public bool onground;
	public int jumps_remaining;




	// Use this for initialization
	void Start () {
		audio=GameAudio.Instance();
		level=LevelLogic.Instance();
		body=GetComponent<Rigidbody2D>();
		dead=false;

		anim=GetComponent<Animator>();


	}
	
	// Update is called once per frame
	void Update () {
		if (dead) return;
		Vector2 currentv=body.velocity;
		float new_vx=joy_x*maxv;
		float new_vy=currentv.y;

		if ( onground || jumps_remaining>0 ) {
			if (start_jump) {
				jumps_remaining-=1;
				new_vy=jump_vy;
				audio.PlayJump();
				//anim.SetBool("jump",true);
			}
		}

		if (new_vx>0) {
			transform.localScale=new Vector2(1,1);
		} else if (new_vx<0) {
			transform.localScale=new Vector2(-1,1);
		}



		body.velocity=new Vector2(new_vx,new_vy);

	}


	void Death() {
		dead=true;
		body.velocity=new Vector2(0,0);
		body.gravityScale=0;
		level.PLayerDied();
		anim.SetTrigger("die");
		anim.SetBool("jump",false);
	}

	void Win() {
		body.velocity=new Vector2(0,0);
		level.PLayerWin();
	}

	public void OnTriggerEnter2D(Collider2D col) {
		int otherlayer = col.gameObject.layer;
		if ( (1<<otherlayer&groundlayers.value) != 0) {
			onground=true;
			anim.SetBool("jump",false);
			jumps_remaining=max_jumps;
		}
		if ( (1<<otherlayer&killLayers.value) != 0) {
			Death();
		}
		if ( (1<<otherlayer&endLayers.value) != 0) {
			Win();
		}

	}

	public void OnTriggerExit2D(Collider2D col) {
		int otherlayer = col.gameObject.layer;
		if ( (1<<otherlayer&groundlayers.value) != 0) {
			onground=false;
			anim.SetBool("jump",true);
		}
	}


}
