﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class LevelLogic : MonoBehaviour {

	public int levelnum;

	GameAudio audio;

	GameObject respawn;

	public GameObject playerPrefab;
	
	public GameObject player;
	public GameObject camera;


	public static LevelLogic Instance() {
		GameObject g = GameObject.Find("level");
		if (g != null) return g.GetComponent<LevelLogic>();
		return null;
	}


	// Use this for initialization
	void Start () {
		audio=GameAudio.Instance();
		camera=GameObject.FindWithTag("MainCamera");
		respawn=GameObject.Find("respawn");
		if (respawn!=null) {
			player=Instantiate(playerPrefab,respawn.transform.position,Quaternion.identity);
		} else {
			Debug.Log("No respawn object");
		}

		CamFollow cf = camera.GetComponent<CamFollow>();
		if (cf!=null) {
			cf.target=player;
		}
	}





	public void PLayerPickMail() {
		audio.PlayPickup();
		audio.StartMusic();
	}


	public void PLayerDied() {
		audio.PlayDie();
		Invoke("RestartLevel",2.0f);
	}


	public void PLayerWin() {
		//audio.PlayDie();
		audio.PlayerEnd();
		Invoke("LoadNextLevel",2.0f);
	}


	void LoadNextLevel() {
		GameLogic.thegame.LoadNextLevel();
	}

	void RestartLevel() {
		Scene estaescena = SceneManager.GetActiveScene();
		SceneManager.LoadScene(estaescena.name);
	}
}
