﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
public class Wander : MonoBehaviour {
	public float alfapos;
	public float dalfapersec=0.25f;

	public bool goandback;

	float tlast0;
	float period;
	float tnext;

	LinearMovePath path = null;
	// Use this for initialization
	void Start () {
		if (dalfapersec==0) dalfapersec=0.001f;
		if (transform.parent!=null) {
			path=transform.parent.GetComponent<LinearMovePath>();
			tlast0=-alfapos/dalfapersec;
			period=2*Mathf.Abs(1/dalfapersec);
			if (tlast0>0) tlast0-=period;
			tnext=tlast0+period;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (path!=null) {
			if (Application.isPlaying) {
				float t = Time.time;
				while (t>tnext) {
					tlast0=tnext;
					tnext=tlast0+period;
				}
				alfapos=(t-tlast0)*Mathf.Abs(dalfapersec);
				if (alfapos>1.0f) {
					if (goandback) {
						alfapos=2.0f-alfapos;
					} else {
						alfapos=alfapos-1.0f;
					}
				}
			}
			transform.position=path.GetPos(alfapos);
		}
	}
}
